"""Statistical info about score database."""

from scores import scores
from playlist import pl
import main
import ui
from colors import colors

class Stats:
    """Borg pattern, read ActiveState recipes."""
    _state = {} # shared state
    tracks_played = 0

    def __init__(self):
        self.__dict__ = self._state

    def all(self):
        ui.tracks_window = 0
        ui.do_clear = 1
        rows = [0]*10
        l = len(scores._dict)
        for s in scores._dict.values():
            for i in range(10):
                if i*10 < s <= i*10+10:
                    rows[i] += 1
        text = """
        \tScore statistics\n
        score \t\t tracks \t percentage\n\n"""

        bar = '='
        for i in range(10):
            perc = round(float(rows[i])*100/l)
            text += "\t%2d to %d: \t %d \t\t %2d%% |%s\n" % (i*10+1, i*10+10, 
                rows[i], perc, (bar*int(round((perc/2)))))
        text += "\n \tTotal:     \t %d" % l
        ui.doredraw=0
        ui.fsdisplay(text)


    def playlist(self):
        ui.tracks_window = 0
        ui.do_clear = 1
        rows = [0]*10
        notset = 0
        for album in pl.albums:
            for track in album.tracks:
                name = track.fname.lower()
                if scores._dict.has_key(name):
                    s = scores._dict[name]
                    for i in range(10):
                        if i*10 < s <= i*10+10:
                            rows[i] += 1
                else:
                    notset += 1

        text = "\t\tScore statistics\n\n"
        text += "  \tscore \t\t tracks \t percentage \n\n"
        perc_ns = round(float(notset)*100/pl.tracksnum)
        bar = '='
        text += "  \tnot set: \t %d \t\t %2d%% %s\n" % (notset, perc_ns,
            bar*int(round((perc_ns/2))))
        for i in range(10):
            perc = round(float(rows[i])*100/pl.tracksnum)
            text += " \t%2d to %d: \t %d \t\t %2d%% %s\n" % (i*10+1, i*10+10, 
                rows[i], perc, bar*int(round((perc/2))))
        text += "\n \tTotal:     \t %d" % pl.tracksnum
        ui.fsdisplay(text)

stats = Stats()
